import de from "dotenv";
de.config();

if (!process.env["DEFAULT_USER_PASSWORD"] || process.env["DEFAULT_USER_PASSWORD"].length < 8) {
    throw new Error("DEFAULT_USER_PASSWORD must be set and at least 8 characters long.");
}
export const DefaultPassword: string = process.env["DEFAULT_USER_PASSWORD"];

if (!process.env["ROOT_DOMAIN"]) {
    throw new Error("ROOT_DOMAIN must be set");
}
export const RootDomain: string = process.env["ROOT_DOMAIN"];

if (!process.env["DATA_ROOT"]) {
    throw new Error("DATA_ROOT must be set");
}
export const DataRoot: string = process.env["DATA_ROOT"];

if (!process.env["PORT"] || !parseInt(process.env["PORT"]) || parseInt(process.env["PORT"]) < 1 || parseInt(process.env["PORT"]) > 65535) {
    throw new Error("PORT must be set and be an integer between 1 and 65535");
}
export const Port: number = parseInt(process.env["PORT"]);

if (!process.env["PROTO"]) {
    throw new Error("PROTO must be set");
}
export const Protocol: string = process.env["PROTO"];