(function() {
    // Local Storage TODOs:
    // - Consistent order operation with the server
    // - Compressing requests
    // - websocket and firing storage events

    function createStorage(name) {
        const backingStore = new Map();
        let keys = [];
    
        function post(endpoint, body) {
            fetch("/cgi-bin/rpc/storage/" + name + "/" + endpoint, {
                method: "POST",
                body: JSON.stringify(body),
                headers: {
                    "Content-Type": "application/json"
                }
            }).then(res => res.json()).then(r => {
                if (r.ok) {
                    console.log("Sync ok");
                } else {
                    console.error("Sync fucked");
                }
            });
        }

        function getKey(key) {
            if (backingStore.has(key.toString())) {
                return backingStore.get(key.toString());
            }
    
            return null;
        }

        function hasKey(key) {
            return backingStore.has(key.toString());
        }

        function setKey(key, value) {
            if (name === "sessionStorage") {
                try {
                    const xhr = new XMLHttpRequest();
                    xhr.open("POST", "/cgi-bin/rpc/storage/" + name + "/upsert", false);
                    xhr.send(JSON.stringify({
                        key: key.toString(),
                        value: value.toString()
                    }));
                } catch(e) {
                    // fucking try anything idk
                    post("upsert", {
                        key: key.toString(),
                        value: value.toString()
                    })
                    navigator.sendBeacon("/cgi-bin/rpc/storage/" + name + "/upsert", JSON.stringify({
                        key: key.toString(),
                        value: value.toString()
                    }))
                }
            } else {
                post("upsert", {
                    key: key.toString(),
                    value: value.toString()
                })
            }

            if (keys.indexOf(key.toString()) === -1) {
                keys.push(key.toString());
            }

            backingStore.set(key.toString(), value.toString());
        }

        function removeKey(key) {
            post("remove", {
                key: key.toString()
            })

            if (keys.indexOf(key.toString()) !== -1) {
                keys = keys.filter(k => k !== key.toString());
            }
    
            backingStore.delete(key);
        }

        function clear() {
            post("clear", {});
    
            keys = [];
    
            backingStore.clear();
        }

        function getKeyByIndex(index) {
            let realIndex = Number(index);
            if (Number.isNaN(realIndex)) {
                return null;
            }
    
            if (realIndex < 0 || realIndex >= keys.length) {
                return null;
            }
    
            return keys[realIndex];
        }

        const api = {
            "clear": clear,
            "getItem": getKey,
            "setItem": setKey,
            "removeItem": removeKey,
            "key": getKeyByIndex,
            "__rdh_debug": function() {
                console.log(keys, backingStore);
            }
        }

        Object.defineProperty(window, name, {
            value: new Proxy({}, {
                set(_, key, value, __) {
                    setKey(key, value);
                },
                get(_, k, __) {
                    if (api[k]) {
                        return api[k];
                    }
        
                    if (k === "length") {
                        return keys.length;
                    }
        
                    return getKey(k);
                },
                ownKeys(_) {
                    return [...keys];
                },
                has(_, k) {
                    return hasKey(k);
                },
                getOwnPropertyDescriptor(_, k) {
                    const exists = hasKey(k);
                    if (!exists) return undefined;
                    return {
                        value: getKey(k),
                        writable: true,
                        enumerable: true,
                        configurable: true
                    }
                },
                isExtensible() {
                    return true;
                }
            }),
            writable: false,
            configurable: false
        });

        const xhr = new XMLHttpRequest();
        xhr.open("GET", "/cgi-bin/rpc/storage/" + name + "/read_all", false);
        xhr.send(null);
    
        if (xhr.status !== 200) {
            alert("it appears to be fucked");
            window.stop();
        }
    
        const responseBody = JSON.parse(xhr.responseText);
        for (let { key, value } of responseBody) {
            keys.push(key);
            backingStore.set(key, value);
        }
    }


    let deadline = Date.now() + 1000;
    while (Date.now() < deadline){};

    createStorage("localStorage");
    createStorage("sessionStorage");


    // DIE. DIE. DIE. (IndexedDB is hell to implement. I will do it later, for now zap it away so games fall back to localstorage.)
    Object.defineProperty(window, "indexedDB", {
        value: undefined,
        writable: false,
        configurable: false,
        enumerable: false
    });
})();