import { HTMLRewriter } from "html-rewriter-wasm";
import fs from "fs";
import stream from "node:stream";

export async function injectStandardHeader(filePath: string, output: stream.Writable) {
    const fstream = fs.createReadStream(filePath);
    
    const webStream = stream.Readable.toWeb(fstream);

    const rewriter = new HTMLRewriter((outputChunk) => {
        output.write(outputChunk);
    });

    rewriter.on('head', {
        element(element) {
            console.log(element);
            element.prepend(`<script src="/cgi-bin/static/standard.js"></script>`, {
                html: true
            });
        }
    });

    const reader = webStream.getReader();
    while(1) {
        const result = await reader.read();
        if (result.done) {
            rewriter.end();
            rewriter.free();
            output.end();
            break;
        }

        rewriter.write(result.value);
    }
}